// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------

float4x4 wvp                : WorldViewProjection;
texture tex0                : Texture;
float4 object_color         : ObjectColor;
float4 material_diffuse     : Diffuse;
float4 uv_offset;
float uv_tile = 4.0;
//float alpha = 1.0;

sampler samp = sampler_state
{
    Texture = (tex0);
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;    
	AddressU = Wrap;
	AddressV = Wrap;
};

// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VSOutput
{
    float4 pos  : POSITION;
    float4 col  : COLOR0;
    float2 tex  : TEXCOORD0;
};

VSOutput VSuvanim(
    float4 pos			    : POSITION,		// f̒_
    float2 tex			    : TEXCOORD0    // eNX`W
){
    VSOutput output = (VSOutput)0;
	
	output.pos = mul(pos,wvp);
    //output.col = float4(alpha,alpha,alpha,0.0);
    //tex += float2(u_offset, v_offset);
    tex += uv_offset.xy;
    tex.y /= uv_tile;
    output.tex = tex;

    return output;
}

float4 PS(
    float4 col  : COLOR0,
    float2 tex  : TEXCOORD0
     ) : COLOR
{
    //return tex2D( samp, tex ) * col;
    return tex2D( samp, tex );
}

technique TechUVAnim
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = true;
        
        VertexShader = compile vs_2_0 VSuvanim();
        PixelShader = compile ps_2_0 PS();
    }
}

