// ice.fx
// Xp
// P0 F
// P1 nCCg

float4x4 wvp         	        : WorldViewProjection;
float4 light_direction[4] 	: LightDirection;
float4 eye_direction 	: EyeDirection;
texture tex0                : Texture;

sampler samp = sampler_state
{
    Texture = (tex0);
};
texture tex1 <string name="data\\fx\\iceSP.dds";>;
sampler samp1 = sampler_state
{
    Texture = (tex1);
};

struct VSOutput0
{
    float4 pos      : POSITION;
    float2 tex      : TEXCOORD0;
	float4 col		: COLOR0;
};

VSOutput0 VS0(
    float4 pos              : POSITION,
    float2 tex			    : TEXCOORD0,
    float3 normal		    : NORMAL
){
    VSOutput0 output = (VSOutput0)0;
    output.pos = mul( pos, wvp );
    output.tex = tex;
	// Kxɓ
    float sp = dot( eye_direction, normal);
	sp = min(1.5 - sp * sp, 0.8);
	output.col.rgb = 1.0;
	output.col.a = sp;

    return output;
}

float4 PS0(VSOutput0 In) : COLOR
{
    return tex2D( samp, In.tex ) * In.col;
}

struct VSOutput1
{
    float4 pos      : POSITION;
    float4 col    : COLOR0;
    float4 colh    : COLOR1;
    float2 tex      : TEXCOORD0;
};

VSOutput1 VS1(
    float4 pos              : POSITION,
    float2 tex			    : TEXCOORD0,
    float3 normal		    : NORMAL
){
    VSOutput1 output = (VSOutput1)0;
    output.pos = mul( pos, wvp );

    output.col.a = 1.0;
    output.colh.a = 1.0;
    output.tex = tex;
    float sp = dot( light_direction[0], normal);
    output.colh.rgb = sp * sp * sp * sp; // nCCgi
    output.col.rgb = output.colh.rgb * 0.5;

    return output;
}

float4 PS1(VSOutput1 In) : COLOR
{
    return tex2D( samp1, In.tex ) * In.col + In.colh;
}

technique Tech_Ice
{
    pass P0
    {
        VertexShader = compile vs_2_0 VS0();
		PixelShader = compile ps_2_0 PS0();
        AlphaBlendEnable = TRUE;
        CullMode         = CCW;
        ZEnable = false; // layerLɂ邽
    }

     pass P1
     {
         VertexShader = compile vs_2_0 VS1();
 		 PixelShader = compile ps_2_0 PS1();
         AlphaBlendEnable = true;
         DestBlend        = ONE; 
         CullMode         = CCW;
        ZEnable = false;
     }
}
