// ϐ
float4x4 wvp                : WorldViewProjection;
texture tex0                : Texture;
float4 object_color         : ObjectColor;
float patnum = 1.0;
float patid = 0.0;

sampler samp = sampler_state
{
    Texture = (tex0);
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

// _VF[_
struct VSOutput
{
    float4 pos  : POSITION;
    float4 col  : COLOR0;
    float2 tex  : TEXCOORD0;
};
VSOutput VS(
    float4 pos			    : POSITION,		// f̒_
    float2 tex			    : TEXCOORD0    // eNX`W
){
    VSOutput output = (VSOutput)0;
	
	output.pos = mul(pos,wvp);
    output.col = object_color;
    output.tex = tex;

    return output;
}

VSOutput VSpatanim(
    float4 pos			    : POSITION,		// f̒_
    float2 tex			    : TEXCOORD0    // eNX`W
){
    VSOutput output = (VSOutput)0;
	
	output.pos = mul(pos,wvp);
    output.col = object_color;
	tex.x /= patnum;
	tex.x += patid / patnum;
    output.tex = tex;

    return output;
}

float4 PS(
    float4 col  : COLOR0,
    float2 tex  : TEXCOORD0
     ) : COLOR
{
    return tex2D( samp, tex ) * col;
}

float4 PS2(
    float4 col  : COLOR0,
    float2 tex  : TEXCOORD0
     ) : COLOR
{
    return tex2D( samp, tex );
}

float4 PS3(
    float4 col  : COLOR0,
    float2 tex  : TEXCOORD0
     ) : COLOR
{
    return tex2D( samp, tex ) + col;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique Tech_Add
{
    pass P0
    {
        AlphaBlendEnable = true;
        DestBlend        = ONE;  
    }
}

technique Tech_Alpha
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = False;
        AlphaBlendEnable = TRUE;
        SrcBlend         = SRCALPHA;
        DestBlend        = InvSrcAlpha; 
    	CullMode = None;
    }
}

technique Tech_Alpha_OC
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = False;
        AlphaBlendEnable = TRUE;
        SrcBlend         = SRCALPHA;
        DestBlend        = InvSrcAlpha; 
    	CullMode = None;

        VertexShader = compile vs_2_0 VS();
        PixelShader = compile ps_2_0 PS();
    }
}

technique Tech_Add_OC
{
    pass P0
    {
        AlphaBlendEnable = true;
        DestBlend        = ONE;  

        VertexShader = compile vs_2_0 VS();
        PixelShader = compile ps_2_0 PS();
    }
}

technique Tech_Multi
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = False;
        AlphaBlendEnable = TRUE;
        SrcBlend         = DESTCOLOR;
        DestBlend        = ZERO; 
    	CullMode = None;
    }
}

technique Tech_Add_Anim
{
    pass P0
    {
        AlphaBlendEnable = true;
        DestBlend        = ONE;  

        VertexShader = compile vs_2_0 VSpatanim();
        PixelShader = compile ps_2_0 PS();
    }
}

technique Tech_Alpha_Anim
{
    pass P0
    {
        ZEnable = true;
        ZWriteEnable = False;
        AlphaBlendEnable = TRUE;
        SrcBlend         = SRCALPHA;
        DestBlend        = InvSrcAlpha; 
    	CullMode = None;

        VertexShader = compile vs_2_0 VSpatanim();
        PixelShader = compile ps_2_0 PS();
    }
}
