# -*- coding: utf_8 -*-
# 実績　そのうち付けたい
"""
実績　候補

*over９chain、1,000
*1stショット９chain　>９連鎖ちょうど 10,000
*over１５chain 3,000
*over３０chain 10,000９の倍数にしてもいいけど
*over50chain 100,000
*over90chain 100,000
*サイクルショット：赤、緑、黄の順に一発ずつショットをうつ
*item3：赤、緑、黄の順にアイテムを取る
*item5：赤、緑、黄、紫、青の順にアイテムを取る
三色同刻：赤、緑、黄を３個ずつ順番に取る
同色：同じ色のアイテムを９回連続で取る
飽食：500以上白氷を生成する
馬鹿の一分（いちぶん）１分間ノーショット 10,000
factorial：チェインを１，２，３…９と続けて取る


得点と難易度のバランスはもうちょっと詰めな決まらん
"""

ANUM = 10

class Achievement(object):
    """
    実績(コンボ)管理
    """
    def __init__(self):
        self.reset()

    def reset(self):
        self.Flags = [[False, 0] for i in range(ANUM)]

        self.checkTbl = {}
        # 取得可能フラグ、回数、処理用関数
        self.checkTbl['over9'] = [True, 0, self.evOver9]
        self.checkTbl['over15'] = [True, 0, self.evOver15]
        self.checkTbl['over30'] = [True, 0, self.evOver30]
        self.checkTbl['over50'] = [True, 0, self.evOver50]
        self.checkTbl['over99'] = [True, 0, self.evOver99]
        self.checkTbl['firstjust9'] = [True, 0, self.evFirstjust9]
        self.checkTbl['item3'] = [True, 0, self.evItem3]
        self.checkTbl['item5'] = [True, 0, self.evItem5]
        self.checkTbl['shotmode'] = [True, 0, self.evShotmode]

        self.que = []

        self.Ffirstshot = True
        self.Fitem3 = 0
        self.Fitem5 = 0
        self.Fshotmode = 0

    #def load(self, f):
    #    self.Flags[] = f

    def check(self, args):
        """
        各条件を個別にチェックする
        args['type']
        args['param']
        """
        type = args['type']
        param = args['param']
        if type == 'shotcnt':
            if param >= 2:
                self.Ffirstshot = False
        if type == 'chain':
            if param == 9 and self.checkTbl['firstjust9'][0] and self.Ffirstshot:
                self.checkTbl['firstjust9'][0] = False # 一回のみ
                self.checkTbl['firstjust9'][1] += 1
                self.que.append('firstjust9')
            if param >= 9 and self.checkTbl['over9'][0]:
                self.checkTbl['over9'][0] = False # 一回のみ
                self.checkTbl['over9'][1] += 1
                self.que.append('over9')
            if param >= 15 and self.checkTbl['over15'][0]:
                self.checkTbl['over15'][0] = False # 一回のみ
                self.checkTbl['over15'][1] += 1
                self.que.append('over15')
            if param >= 30 and self.checkTbl['over30'][0]:
                self.checkTbl['over30'][0] = False # 一回のみ
                self.checkTbl['over30'][1] += 1
                self.que.append('over30')
            if param >= 50 and self.checkTbl['over50'][0]:
                self.checkTbl['over50'][0] = False # 一回のみ
                self.checkTbl['over50'][1] += 1
                self.que.append('over50')
            if param >= 99 and self.checkTbl['over99'][0]:
                self.checkTbl['over99'][0] = False # 一回のみ
                self.checkTbl['over99'][1] += 1
                self.que.append('over99')
        if type == 'getitem':
            if 4 >= param >= 0: # 色循環
                if param == self.Fitem3:
                    self.Fitem3 += 1
                    if self.Fitem3 == 3:
                        self.Fitem3 = 0
                        self.checkTbl['item3'][1] += 1
                        self.que.append('item3')
                else:
                    self.Fitem3 = 0
                if param == self.Fitem5:
                    self.Fitem5 += 1
                    if self.Fitem5 == 5:
                        self.Fitem5 = 0
                        self.checkTbl['item5'][1] += 1
                        self.que.append('item5')
                else:
                    self.Fitem5 = 0
        if type == 'shotmode':
            if param == self.Fshotmode:
                self.Fshotmode += 1
                if self.Fshotmode == 3:
                    self.Fshotmode = 0
                    self.checkTbl['shotmode'][1] += 1
                    self.que.append('shotmode')
            #else: #単発
            #    self.Fshotmode = 0


    def evOver9(self, event):
        event.append({'type':'frameachievement','args':{'type':0}})
        event.append({'type':'score', 'args':100000})
        event.append({'type':'setcombo', 'args':None})
        print 'over9'

    def evOver15(self, event):
        event.append({'type':'frameachievement','args':{'type':1}})
        event.append({'type':'score', 'args':10000})
        event.append({'type':'setcombo', 'args':None})
        print 'over15'

    def evOver30(self, event):
        event.append({'type':'frameachievement','args':{'type':2}})
        event.append({'type':'score', 'args':30000})
        event.append({'type':'setcombo', 'args':None})
        print 'over30'

    def evOver50(self, event):
        event.append({'type':'frameachievement','args':{'type':3}})
        event.append({'type':'score', 'args':50000})
        event.append({'type':'setcombo', 'args':None})
        print 'over50'

    def evOver99(self, event):
        event.append({'type':'frameachievement','args':{'type':4}})
        event.append({'type':'score', 'args':100000})
        event.append({'type':'setcombo', 'args':None})
        print 'over99'

    def evFirstjust9(self, event):
        event.append({'type':'frameachievement','args':{'type':5}})
        event.append({'type':'score', 'args':1000000})
        event.append({'type':'setcombo', 'args':None})
        print 'firstjust9'

    def evItem3(self, event):
        event.append({'type':'frameachievement','args':{'type':6}})
        event.append({'type':'score', 'args':20000})
        event.append({'type':'setcombo', 'args':None})
        print 'item3'

    def evItem5(self, event):
        event.append({'type':'frameachievement','args':{'type':7}})
        event.append({'type':'score', 'args':50000})
        event.append({'type':'setcombo', 'args':None})
        print 'item5'

    def evShotmode(self, event):
        event.append({'type':'frameachievement','args':{'type':8}})
        event.append({'type':'score', 'args':10000})
        event.append({'type':'setcombo', 'args':None})
        print 'shotmode'

    def update(self, event):
        for i in self.que:
            self.checkTbl[i][2](event)
        self.que = []
    
