# -*- coding: utf_8 -*-
"""
敵オブジェクト
"""
from math import sin, cos, pi
from eff import *
from actor import *
from util import *



# mixin
class Pos(object):
    def setPos(self, p):
        self.root.pos = p
    
    def getPos(self):
        return self.root.pos
    
    pos = property(getPos, setPos, None, None)

class Task(object):
    def taskloop(self, que):
        pass

    def taskdead(self, que):
        que.append({'type':'se', 'args':self.expseID})
        que.append({'type':'score', 'args':self.score})
        self.root.exp()
        self.Fnohit = 2
        self.ev.add('task', 'end')
        self.ev.clear()

    def taskend(self, que):
        self.root.kill()
        return True

class HittestLen(object):
    def hitTest(self, hr):
        if self.Fnohit != 1 or hr[2] == 0:
            return False
        if v.length(hr[0] - self.root.pos) < self.hit + hr[1]:
            self.hp -= hr[2]
            # todo hit処理
            if self.hp <= 0:
                self.ev.add('task', 'dead')
            return True


# 
class Splite(Pos, Task, HittestLen, Space):
    """
    スプライトの親
    """
    def __init__(self, args):
        self.wind = wind
        self.root = ml.create(args['type'])
        self.root.pos = args['pos']
        self.args = args
        self.task = 'loop'
        self.taskTbl = {
            'loop': self.taskloop,
            'dead': self.taskdead,
            'end': self.taskend,
            }
        self.ev = Event()
        self.localframe = 0
        self.Fnohit = 1
        self.expID = 'expA' # 爆発パターン
        self.expseID = 'expZakoA'

        self.chainlevel = 0

    def bomb(self, hr):
        if self.Fnohit != 1:
            return False
        if v.length(hr[0] - self.root.pos) < self.hit + hr[1]:
            self.hp = 0
            self.ev.add('task', 'dead')
            return True

    def update(self, frame, que):
        self.localframe += 1
        for i in self.ev:
            dt = i[2]
            if i[0] == 'task':
                self.task = i[1]
            elif i[0] == 'track':
                self.root.setTrackAnime(i[1])
            elif i[0] == 'shot':
                que.append(i[1])
        if self.root.checkRange2(): # 出現領域より外
            self.ev.add('task', 'end')

        self.root.update(self.localframe)
        return self.taskTbl[self.task](que)

#-----------------------------------------------------------------------------
# cloud
class CloudMixin(object):
    def taskdead(self, que):
        # TODO ショット時の効果音
        #que.append({'type':'se', 'args':self.expseID})
        que.append({'type':'score', 'args':self.score})
        self.root.exp()
        self.Fnohit = 2
        self.ev.add('task', 'loop')
        self.ev.add('task', 'end', 20)
        self.ev.clear()

    def taskdead2(self, que):
        que.append({'type':'se', 'args':self.expseID})
        que.append({'type':'ice', 'args':{'pos':self.root.pos, 'type':self.iceID}})
        que.append({'type':'score', 'args':self.score})
        self.root.exp()
        self.Fnohit = 2
        self.ev.add('task', 'loop')
        self.ev.add('task', 'end', 20)
        self.ev.clear()

    def hitTest2(self, hr):
        if self.Fnohit != 1 or hr[2] == 0 or self.root.checkRange():
            return False
        #if v.length(hr[0] - self.root.pos) < self.hit + hr[1]:
        if v.length(hr[0] - self.root.pos) < hr[1]:
            self.ev.add('task', 'dead2')
            return True

class SpliteCloudW(CloudMixin, Splite):
    """
    雲白
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'freeze'
        self.iceID = 'iceW'
        self.taskTbl['dead2'] = self.taskdead2
        spd = uniform(0.9, 1.1)
        self.root.setAnim('wind',{"wind":self.wind, "spd":spd})

class SpliteCloudR(CloudMixin, Splite):
    """
    雲赤
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'freeze'
        self.iceID = 'iceR'
        self.taskTbl['dead2'] = self.taskdead2
        spd = uniform(0.9, 1.1)
        self.root.setAnim('wind',{"wind":self.wind, "spd":spd})

class SpliteCloudG(CloudMixin, Splite):
    """
    雲緑
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'freeze'
        self.iceID = 'iceG'
        self.taskTbl['dead2'] = self.taskdead2
        spd = uniform(0.9, 1.1)
        self.root.setAnim('wind',{"wind":self.wind, "spd":spd})

class SpliteCloudB(CloudMixin, Splite):
    """
    雲緑
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'freeze'
        self.iceID = 'iceB'
        self.taskTbl['dead2'] = self.taskdead2
        spd = uniform(0.9, 1.1)
        self.root.setAnim('wind',{"wind":self.wind, "spd":spd})

class SpliteCloudY(CloudMixin, Splite):
    """
    雲緑
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'freeze'
        self.iceID = 'iceY'
        self.taskTbl['dead2'] = self.taskdead2
        spd = uniform(0.9, 1.1)
        self.root.setAnim('wind',{"wind":self.wind, "spd":spd})

class SpliteCloudP(CloudMixin, Splite):
    """
    雲緑
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'freeze'
        self.iceID = 'iceP'
        self.taskTbl['dead2'] = self.taskdead2
        spd = uniform(0.9, 1.1)
        self.root.setAnim('wind',{"wind":self.wind, "spd":spd})


# ice
class IceMixin(object):
    def hitTestChain(self, hr):
        if self.Fnohit != 1:
            return False
        if v.length(hr[0] - self.root.pos) < self.hit + hr[1]:
            self.chain = hr[2] + 1
            self.ev.add('task', 'dead')
            return True

    def taskdead(self, que):
        que.append({'type':'se', 'args':self.expseID})
        que.append({'type':'item', 'args':{'pos':self.root.pos, 'chain':self.chain, 'type':self.itemID}})
        que.append({'type':'chain', 'args':{'pos':self.root.pos, 'chain':self.chain, 'type':'chain'}})
        que.append({'type':'addchain', 'args':self.chain})
        que.append({'type':'score', 'args':self.score})
        self.root.exp()
        self.Fnohit = 2
        self.ev.add('task', 'end')
        self.ev.clear()

class SpliteIceW(IceMixin, Splite):
    """
    氷白　通常
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10 * 0.38 # 20.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'ice'
        self.itemID = 'itemW'
        spd = 0.1
        self.root.setAnim('windR',{"wind":self.wind, "spd":spd})

class SpliteIceR(IceMixin, Splite):
    """
    氷赤 自機狙い
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10 * 0.38 # 20.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'ice'
        self.itemID = 'itemR'

        p = args['player'].pos
        spd = vnorm(p - self.root.pos)
        spd *= 0.8
        self.root.setAnim('linerR',{"spd":spd})

class SpliteIceG(IceMixin, Splite):
    """
    氷緑　テイルショット
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10 * 0.38 # 20.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'ice'
        self.itemID = 'itemG'

        p = args['player'].pos
        spd = vnorm(p - self.root.pos)
        spd *= 0.8
        self.root.setAnim('linerR',{"spd":spd})

class SpliteIceB(IceMixin, Splite):
    """
    氷青　ボム
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10 * 0.38 # 20.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'ice'
        self.itemID = 'itemB'

        p = args['player'].pos
        spd = vnorm(p - self.root.pos)
        spd *= 0.8
        self.root.setAnim('linerR',{"spd":spd})

class SpliteIceY(IceMixin, Splite):
    """
    氷黄　貫通弾
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10 * 0.38 # 20.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'ice'
        self.itemID = 'itemY'

        p = args['player'].pos
        spd = vnorm(p - self.root.pos)
        spd *= 0.8
        self.root.setAnim('linerR',{"spd":spd})

class SpliteIceP(IceMixin, Splite):
    """
    氷紫　結界ｕｐ
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10 * 0.38 # 20.0
        self.hp = 1
        self.score = 1
        self.chain = 0
        self.expseID = 'ice'
        self.itemID = 'itemP'

        p = args['player'].pos
        spd = vnorm(p - self.root.pos)
        spd *= 0.8
        self.root.setAnim('linerR',{"spd":spd})


# item
class SpliteItemW(Splite):
    """
    カキ氷　白通常
    """
    def __init__(self, args):
        chain = args['chain']
        # TODO スコア、倍率切り分けは要調整
        if 10 > chain >= 5:
            args['type'] = 'itemW2'
            self.score = 20 * (chain + 1)
        elif 15 > chain >= 10:
            args['type'] = 'itemW3'
            self.score = 30 * (chain + 1)
        elif chain >= 15:
            args['type'] = 'itemW4'
            self.score = 40 * (chain + 1)
        else:
            self.score = 10 * (chain + 1)
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.expseID = 'item'
        self.id = 5

        self.root.setAnim('item',{"player":args['player'].getRoot()})

class SpliteItemR(Splite):
    """
    カキ氷　赤　ノーマルショット　＋１
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 10 * (args['chain'] + 1)
        self.chain = args['chain']
        self.expseID = 'item'
        self.id = 0

        spd = 0.3
        self.root.setAnim('item2',{"player":args['player'].getRoot(), "wind":self.wind, "spd":spd})

class SpliteItemG(Splite):
    """
    カキ氷　緑　テイルショット　＋２ 
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 10 * (args['chain'] + 1)
        self.chain = args['chain']
        self.expseID = 'item'
        self.id = 1

        spd = 0.3
        self.root.setAnim('item2',{"player":args['player'].getRoot(), "wind":self.wind, "spd":spd})

class SpliteItemB(Splite):
    """
    カキ氷　青　ボム
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 10 * (args['chain'] + 1)
        self.chain = args['chain']
        self.expseID = 'item'
        self.id = 4

        spd = 0.3
        self.root.setAnim('item2',{"player":args['player'].getRoot(), "wind":self.wind, "spd":spd})

class SpliteItemY(Splite):
    """
    カキ氷　黄　貫通弾　＋５
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 10 * (args['chain'] + 1)
        self.chain = args['chain']
        self.expseID = 'item'
        self.id = 2

        spd = 0.3
        self.root.setAnim('item2',{"player":args['player'].getRoot(), "wind":self.wind, "spd":spd})

class SpliteItemP(Splite):
    """
    カキ氷　紫　BoI
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.hit = 10.0
        self.hp = 1
        self.score = 10 * (args['chain'] + 1)
        self.chain = args['chain']
        self.expseID = 'item'
        self.id = 3

        spd = 0.3
        self.root.setAnim('item2',{"player":args['player'].getRoot(), "wind":self.wind, "spd":spd})

class SpliteChain(Splite):
    """
    連鎖弾
    """
    def __init__(self, args):
        Splite.__init__(self, args)
        self.ev.add('task', 'end', 50)

    def getHitrange(self):
        if 5 == self.localframe: 
            return (self.pos, 20, self.args['chain'])
        return False


spliteEnTbl = {
        'cloudW':SpliteCloudW,
        'cloudR':SpliteCloudR,
        'cloudG':SpliteCloudG,
        'cloudB':SpliteCloudB,
        'cloudY':SpliteCloudY,
        'cloudP':SpliteCloudP,
        'iceW':SpliteIceW,
        'iceR':SpliteIceR,
        'iceG':SpliteIceG,
        'iceB':SpliteIceB,
        'iceY':SpliteIceY,
        'iceP':SpliteIceP,
        'itemW':SpliteItemW,
        'itemR':SpliteItemR,
        'itemG':SpliteItemG,
        'itemB':SpliteItemB,
        'itemY':SpliteItemY,
        'itemP':SpliteItemP,
        'chain':SpliteChain,
    }

