# -*- coding: utf_8 -*-
"""
リソース
"""

from os import listdir, path
from eff import *

def load(p, ext, fn, Fext = False):
    tmp = {}
    for i in listdir(p):
        n, e = path.splitext(i)
        if e.lower() in ext:
            if Fext: # pawn読み込み時は拡張子不要
                tmp[n] = fn(p + n)
            else:
                tmp[n] = fn(p + i)
    return tmp

class Resource(object):
    def __init__(self):
        self.model = load('data/', '.x', ModelData)
        self.tex = load('data/tex/', '.dds', Texture)
        self.fx = load('data/fx/', '.fx', Effect)
        self.anim = load('data/anim/', ('.p', '.amx'), AnimScript, True)
        #self.bg = load('data/bg/', ('.dds', '.jpg'), Texture)
        self.frametex = load('data/frame/', ('.dds', '.png'), Texture)


res = None

def init():
    global res
    res = Resource()

################################
"""
必要になってから読み込む版
"""
def load2(name, p, ext, fn, Fext = False):
    for i in listdir(p):
        n, e = path.splitext(i)
        if n == name:
            if e.lower() in ext:
                if Fext: # pawn読み込み時は拡張子不要
                    return fn(p + n)
                else:
                    return fn(p + i)

_bg = {}

def loadbg(name):
    global _bg
    if not _bg.has_key(name):
        _bg[name] = load2(name, 'data/bg/', ('.dds', '.jpg'), Texture)
    return _bg[name]

class res2(object):
    bg = {}


