# -*- coding: utf_8 -*-
"""
雲の出現管理

内部的なランク
それに応じた雲の生成頻度の設定
0-9

風速と頻度で調整する
"""
from eff import *
from util import *

#SCREENW = 105.0
#SCREENH = 140.0

W = 165
H = 200

# W R G Y B P
ctype = ('cloudW', 'cloudR', 'cloudG', 'cloudY', 'cloudB', 'cloudP')
#              0    1     2     3     4     5     6     7     8     9
timeRinit = (600, 900, 1200, 2400, 1800, 2400, 1800, 2400, 2400, 3600)
#timeRinit = (6000, 900, 1200, 2400, 1800, 2400, 1800, 2400, 3600, 4800) # test
#          0  1  2  3  4  5  6  7  8  9
spdinit = (0, 0, 1, 1, 2, 3, 1, 2, 3, 0)
ccntinit = (# 数字は出現間隔のフレーム数
    #((1500, 1700), (50, 50), (50, 50), (50, 50), (50, 50), (50, 50)), # test
    ((20, 35), (250, 400), (500, 700), (1500, 2000), (1500, 2500), (300, 500)), # 0 慣らし→2
    ((10, 15), (220, 360), (440, 600), (1400, 1800), (1400, 2200), (250, 400)), # 1
    (( 7, 10), (180, 300), (340, 500), (1200, 1500), (1400, 2200), (220, 360)), # 2 逆風、ここまで序盤
    (( 5, 10), (180, 300), (340, 500), (1200, 1500), (1400, 2200), (220, 360)), # 3 白多め、ループ起点
    (( 6, 12), ( 70, 100), ( 30,  50), ( 200,  300), ( 300,  500), (100, 200)), # 4 向きランダム、弾系多め
    (( 4,  8), (120, 200), (340, 500), (1200, 1500), (1400, 2200), (180, 260)), # 5 向きランダム、
    (( 2,  3), ( 70, 100), ( 30,  50), ( 200,  300), ( 300,  500), (100, 200)), # 6 向きランダム、
    (( 3,  6), ( 30,  50), (200, 400), (1000, 2000), ( 300,  500), (200, 300)), # 7 中速中密度
    (( 2,  5), ( 20,  40), ( 80, 140), ( 600, 1200), ( 600,  800), ( 80, 200)), # 8 高速弾避け
    (( 3,  4), ( 10,  30), ( 30,  80), ( 400,  600), ( 100,  200), (100, 140))) # 9 低速高密度稼ぎ

def getArea(area):
    p = (((-W, H), (W, H)), ((W, -H), (W, H)), ((-W, -H), (W, -H)), ((-W, -H), (-W, H)))[area]
    x = randint(p[0][0], p[1][0])
    y = randint(p[0][1], p[1][1])
    return v(x, y, 0)

class stageMan(object):
    def __init__(self):
        self.cnt = 1
        self.timeW = 300
        self.timeR = timeRinit[0]
        self.rank = 0
        self.area = 0

        self.ccnt = [100, 200, 500, 1000, 1500, 300]
        #self.ccnt = [100, 100, 100, 100, 100, 100] # test

    def setCloud(self, type, que):
        self.ccnt[type] -= 1
        if self.ccnt[type] == 0:
            que.append({
                'type':'cloud',
                'args':{'pos':getArea(self.area), 'type':ctype[type]},
                })
            a, b = ccntinit[self.rank][type]
            self.ccnt[type] = randint(a, b)

    def next(self):
        self.rank += 1
        #self.rank = 9 # test
        if self.rank > 9:
            self.rank = 3
        if 2 == self.rank: # 逆風
            self.area = 2
        elif 4 <= self.rank <= 6: # 風向きランダム
            self.area = randint(0,3)
        else:
            self.area = 0

    def update(self, que):
        self.timeW -= 1
        self.timeR -= 1
        if self.timeW == 0:
            que.append({
                'type':'wind',
                'args':{'area':self.area, 'spd':spdinit[self.rank]},
                })
            self.timeW = 300
        if self.timeR == 0:
            self.next()
            print self.rank
            self.timeR = timeRinit[self.rank]
            #self.timeR = 3600
            print self.timeR

        for i in range(6):
            self.setCloud(i, que)

