# -*- coding: utf_8 -*-
"""
入力
デジタル八方向、ボタン二つ版
"""

import ConfigParser

from eff import *

axisTbl = ((v(-0.7, 0.7), v(0.0, 1.0), v(0.7, 0.7)), (v(-1.0, 0.0), v(0.0, 0.0), v(1.0, 0.0)), (v(-0.7, -0.7), v(0.0, -1.0), v(0.7, -0.7)))

class Stick(object):
    def __init__(self,app, section):
        config = ConfigParser.ConfigParser()
        config.read('config.cfg')
        
        self.js_ok = config.getint(section,"js_ok") - 1
        self.js_pose = config.getint(section,"js_pose") - 1
        self.js_bomb = config.getint(section,"js_bomb") - 1
        self.js_shot = config.getint(section,"js_shot") - 1
        
        del config
        
        self.keyboard = Keyboard(app)
        self.joystick = [Joystick(app) for i in range(2)]

        self.okOld = False
        self.cancelOld = False

        self.localframe = 0

    def update(self):
        btn0 = 0  # 決定
        btn1 = 0  # ポーズ
        dx = 1
        dy = 1

        for i in self.joystick:
            data = i.Get()
            if data:
                btn0 += ord(data[7][self.js_ok])
                btn1 += ord(data[7][self.js_pose])

                if data[0] < -900:
                    dx = 0
                elif data[0] > 900:
                    dx = 2
                if data[1] < -900:
                    dy = 0
                elif data[1] > 900:
                    dy = 2

        keyin = self.keyboard.Get()
        if keyin:
            btn0 += ord(keyin[KBS_SPACE])
            btn1 += ord(keyin[KBS_Z])

            if ord(keyin[KBS_LEFT]):
                dx = 0
            elif ord(keyin[KBS_RIGHT]):
                dx = 2
            if ord(keyin[KBS_UP]):
                dy = 0
            elif ord(keyin[KBS_DOWN]):
                dy = 2

        self.ok = btn0
        self.okUp = True if not btn0 and self.okOld else False
        self.okOld = btn0
        self.cancel = btn1
        self.cancelUp = True if not btn1 and self.cancelOld else False
        self.cancelOld = btn1
        self.axis = axisTbl[dy][dx]
    
