# -*- coding: utf_8 -*-
from eff import *
from math import sin, cos, radians
from random import uniform, randint, choice


# 定数
SCALE = 320
SCREENW = 105.0
SCREENH = 140.0
SCREENW2 = 130.0
SCREENH2 = 165.0
#SCREENW2 = 125.0
#SCREENH2 = 160.0

# ベクトル
vlen = v.length
vnorm = v.normalize
vdot = v.dot
vcross = v.cross
V0 = v(0.0, 0.0, 0.0)
V1 = v(1.0, 1.0, 1.0)
VN = vnorm(V1)
VX = v(1.0, 0.0, 0.0)
VY = v(0.0, 1.0, 0.0)
VZ = v(0.0, 0.0, 1.0)
C1 = v(1.0, 1.0, 1.0, 1.0)
C0 = v(0.0, 0.0, 0.0, 0.0)
CA = v(1.0, 1.0, 1.0, 0.0)


# ヘルパー
def rotV(v3D, r1, r2): # ベクトルをZ軸でｒ度回転
    r =radians(uniform(r1, r2))
    c =cos(r)
    s =sin(r)
    x = v3D.x * c - v3D.y * s
    y = v3D.x * s + v3D.y * c
    return v(x, y, 0)

def rotRndZ(r1, r2): # 指定した角度範囲のランダムなベクトル
    r = radians(uniform(r1, r2))
    return v(-sin(r), cos(r), 0)

def rndX():
    x = uniform(-100, 100)
    return VX * x

def rndV():
    x = uniform(-100, 100)
    y = uniform(-100, 100)
    z = uniform(-100, 100)
    return vnorm(v(x, y, z))

def rotZ(r): # r方向のeyeを返す v(0, 1, 0)をZ軸でｒ度回転
    r = radians(r)
    return v(-sin(r), cos(r), 0)

def rotY(r): # r方向のupを返す v(0, 0, -1)をx軸でｒ度回転
    r = radians(r)
    return v(sin(r), 0, -cos(r))

def rndDir():
    r = radians(randint(0, 359))
    return VZ, v(-sin(r), cos(r), 0)

def rndDir2():
    r = radians(randint(0, 359))
    r2 = radians(randint(0, 359))
    return v(0, cos(r2), sin(r2)), v(-sin(r), cos(r), 0)

